package ij2x.plugin;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;

import ij.ImagePlus;
import ij.process.ImageProcessor;
import ij.gui.Toolbar;
import ij2x.gui.ColorChooser;
import ij.plugin.frame.ColorPicker;
import ij2x.plugin.frame.JColorPicker;
import ij.WindowManager;
import ij.gui.Roi;
import ij.gui.GenericDialog;
import java.net.URL;
import ij.IJ;
import ij.ImageJ;
import ij.Prefs;
import ij.plugin.PlugIn;
/**
 * <p>Title: ThreeColor</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) </p>
 * <p>Company: rawak.de</p>
 * @author unbekannt
 * @version 1.0
 */

public class ThreeColor extends JComponent implements PlugIn, ItemListener, ActionListener{

  private BorderLayout borderLayout1;

  protected static Color settingColor;
  protected Color oldsettingColor;
  protected JPanel colorPane;
  protected JPanel colorPanel;
  protected JPanel palettePanel;

  protected GridBagLayout gridBagLayout1;
  protected JPanel[] jPanel = new JPanel[12];
  public JLabel tempLabel;
  public String colorHex;
  protected int maxColumn = 30;
  protected Border border1;
  protected String[] curstringRGB = new String[3];
  protected GridBagLayout gridBagLayout2 = new GridBagLayout();
  protected BorderLayout borderLayout2;
  protected BorderLayout borderLayout3;
  protected boolean pressed = true;
  public String[] stringRGB;
  private ColorIconArea colorIconArea = null;
  public ImagePlus imp;
  private ImageProcessor ip;
  private Vector<JComponent> checkBox;
  public static int tempColor=1;
  private JCheckBox roiCheckbox, fgCheckbox, bgCheckbox, fillCheckbox, strokeCheckbox;
  private ButtonGroup group;
  private boolean background;
  public boolean isShowing=false;
  public static boolean isRoiChecked=JColorPicker.isRoiChecked
                                     , isFGChecked=JColorPicker.isFGChecked
                                              , isBGChecked=JColorPicker.isBGChecked;
            //, isFillChecked=false
            // , isStrokeChecked=false;
  private static ThreeColor instance;
  private ImageJ ij;
  private Image image;
  private long mouseDownTime;
  public static final int DOUBLE_CLICK_THRESHOLD = 650;
  private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
  private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
  private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.LOWERED, Color.lightGray, Color.lightGray);
  private JPanel buttonPanel;
  private JButton ccButton;//=new JButton("C");
  private static boolean colorDialog=false;


  public static ThreeColor getInstance(){
     if(instance == null) instance=new ThreeColor();
  return instance;
  }

  public void run(String arg){
      try {
          ij = IJ.getInstance();
          this.imp=imp;
          if(true){
              jbInit();
              tempColor=JColorPicker.tempColor;
              if(JColorPicker.tempColor==0)settingColor = Roi.getColor();
              else settingColor = Toolbar.isForegroundColor ? Toolbar.getForegroundColor() : Toolbar.getBackgroundColor();
          }
          if (!showDialog())
                  return;
      } catch (Exception ex) {
      ex.printStackTrace();
      }
  }
  boolean showDialog() {
     String[] names = {"Roi Color","ForeGround","Background"};
     boolean[] checked={isRoiChecked, isFGChecked, isBGChecked};
     group=new ButtonGroup();
     GenericDialog gd = new GenericDialog("Colors");
     if (colorDialog) {
             gd.toFront();
             return false;
     }

     colorDialog = true;
     JPanel rgbPanel = new JPanel();
     JLabel rgbLabel = new JLabel(" Three Color ");
     rgbPanel.add(rgbLabel);
     rgbLabel.setBorder(lightGrayBorder);
     gd.addPanel(rgbPanel, GridBagConstraints.WEST, new Insets(0, -5, 5, 0));
     JPanel checkBoxPanel=new JPanel();
     JPanel controlPanel=new JPanel();
     buttonPanel=new JPanel();
     ccButton=createButton(ccButton, "Color Chooser");
     ccButton.setIcon(createIcon("s_cchooser"));
     ccButton.setRolloverIcon(createIcon("s_cchooser_ro"));
     ccButton.setPressedIcon(createIcon("s_cchooser_press"));

     checkBoxPanel.add(gd.addCheckboxGroupPanel(1, 3, names, checked));
     controlPanel.add(checkBoxPanel);
     buttonPanel.setBorder(lightGrayBorder);
     buttonPanel.add(ccButton);
     controlPanel.add(buttonPanel);
     checkBoxPanel.setBorder(lightGrayBorder);
     gd.addPanel(palettePanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));
     gd.addPanel(controlPanel, GridBagConstraints.CENTER, new Insets(0, 0, 0, 0));

     checkBox=gd.getCheckboxes();
     //System.out.println("Size="+checkBox.size());
     roiCheckbox=(JCheckBox)checkBox.elementAt(0);
     fgCheckbox=(JCheckBox)checkBox.elementAt(1);
     bgCheckbox=(JCheckBox)checkBox.elementAt(2);
     //fillCheckbox=(JCheckBox)checkBox.elementAt(3);
     //strokeCheckbox=(JCheckBox)checkBox.elementAt(4);
     group.add(roiCheckbox);
     group.add(fgCheckbox);
     group.add(bgCheckbox);
     //group.add(fillCheckbox);
     //group.add(strokeCheckbox);

     roiCheckbox.addItemListener(this);
     bgCheckbox.addItemListener(this);
     fgCheckbox.addItemListener(this);
     //fillCheckbox.addItemListener(this);
     //strokeCheckbox.addItemListener(this);

     roiCheckbox.setToolTipText("ROI Color");
     bgCheckbox.setToolTipText("Background Color");
     fgCheckbox.setToolTipText("Foreground Color");
     //fillCheckbox.setToolTipText("Fill Color");
     //strokeCheckbox.setToolTipText("Strock Color");

     roiCheckbox.setSelected(isRoiChecked=gd.getNextBoolean());
     fgCheckbox.setSelected(isFGChecked=gd.getNextBoolean());
     bgCheckbox.setSelected(isBGChecked=gd.getNextBoolean());
     if(!isRoiChecked&&!isFGChecked&&!isBGChecked){roiCheckbox.setSelected(true);}
     //roiCheckbox.setSelected(isRoiChecked=tempColor == 0);
     //fgCheckbox.setSelected(isFGChecked=tempColor == 1);
     //bgCheckbox.setSelected(isBGChecked=tempColor == 2);
     //fillCheckbox.setSelected(isFillChecked=gd.getNextBoolean());
     //strokeCheckbox.setSelected(isStrokeChecked=gd.getNextBoolean());

     isRoiChecked=roiCheckbox.isSelected() ;
     if(isRoiChecked){tempColor=0;settingColor=Roi.getColor();}
     isFGChecked=fgCheckbox.isSelected();
     if(isFGChecked){tempColor=1;settingColor=Toolbar.getForegroundColor();}
     isBGChecked=bgCheckbox.isSelected();
     if(isBGChecked){tempColor=2;settingColor=Toolbar.getBackgroundColor();}
     /*isFillChecked=fillCheckbox.isSelected() ;
     if(isFillChecked){tempColor=3;settingColor=Toolbar.getForegroundColor();}
     isStrokeChecked=strokeCheckbox.isSelected() ;
     if(isStrokeChecked){tempColor=4;settingColor=Roi.getDefaultFillColor();}*/
     setSelectedColor(getSelectedColor());
     gd.showDialog();
     if (gd.wasCanceled()){
         colorDialog = false;
         return false;
     }
     isShowing=true;
     colorDialog = false;
     isRoiChecked=gd.getNextBoolean();
     isFGChecked=gd.getNextBoolean();
     isBGChecked=gd.getNextBoolean();
     JColorPicker.isRoiChecked=isRoiChecked;
     JColorPicker.isFGChecked = isFGChecked;
     JColorPicker.isBGChecked =  isBGChecked;
     //isFillChecked=gd.getNextBoolean();
     //isStrokeChecked=gd.getNextBoolean();
     return isShowing;
  }
  private JButton createButton(JButton action, String tooltip){
      action = new JButton();
      action.setToolTipText(tooltip);
      action.addActionListener(this);
      setBorderlessButton(action);
  return action;
  }

   void setBorderlessButton(JButton button){
        button.setMargin(new Insets(0, 0, 0, 0));
        button.setBorderPainted(false);
        button.setContentAreaFilled(false);
        button.setFocusPainted(false);
    }
  private Icon createIcon(String key){
      String dir = Prefs.getString("lutDir");
      String fileName=key+".gif";
      String path = dir+fileName;
      URL url = ij.getClass().getResource(path);
          if (url!=null) {
                  try {
                      image = ij.createImage((ImageProducer)url.getContent());
                  }
                  catch(Exception e) {}
                  if (image!=null) {
                          imp = new ImagePlus("", image);
                          ip = imp.getProcessor();
                  }
          }
      Icon icon = new ImageIcon(url);
  return icon;
  }

  public String getHexColor(){
  return colorHex;
  }
  public void setHexColor(String hexcolor){
    colorHex=hexcolor;
  }
  public Color getSelectedColor(){
  return settingColor;
  }
  public void setSelectedColor(Color color){
      if(color == null)color=Roi.getColor();
      settingColor=color;
      oldsettingColor=settingColor;
      ColorPicker picker = ColorPicker.instance;
      Toolbar toolbar = Toolbar.getInstance();
      setSelectedColor(buttonPanel, color);
      if(tempColor == 0){
       Roi.setColor(color);
       ImagePlus imp = WindowManager.getCurrentImage();
       if (imp!=null && imp.getRoi()!=null) imp.draw();
 }
 else if(tempColor == 1){
  Toolbar.setForegroundColor(color);background=false;
  if(picker instanceof ij.plugin.frame.ColorPicker)
  picker.refresh();
  toolbar.repaint();
}
 else if(tempColor == 2){
  Toolbar.setBackgroundColor(color);background=true;
  if(picker instanceof ij.plugin.frame.ColorPicker)
  picker.refresh();
  toolbar.repaint();
}
      if(tempColor == 3){
       //Roi.setDefaultFillColor(color);
       ImagePlus imp = WindowManager.getCurrentImage();
       if (imp!=null && imp.getRoi()!=null) imp.draw();
 }
      if(tempColor == 4){
       //Toolbar.setForegroundColor(color);background=false;
       ImagePlus imp = WindowManager.getCurrentImage();
       if (imp!=null && imp.getRoi()!=null) imp.draw();
 }
  }
  public void setSelectedColor(JPanel panel, Color color){
      Border colorBorder = BorderFactory.createBevelBorder(bb.LOWERED, color, color);
      panel.setBorder(colorBorder);
  }
  private void jbInit() throws Exception {
      borderLayout1 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      colorPanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      colorPane = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      palettePanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      gridBagLayout1 = (GridBagLayout) Beans.instantiate(getClass().getClassLoader(), GridBagLayout.class.getName());
      for(int i=0; i < jPanel.length; i++){
        jPanel[i] = (JPanel) Beans.instantiate(getClass().getClassLoader(),
                                               JPanel.class.getName());
      }
      tempLabel = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
      borderLayout2 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      borderLayout3 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      border1 = BorderFactory.createLineBorder(Color.black,1);
      this.setLayout(borderLayout1);
      if(colorIconArea == null){
        colorIconArea = new ColorIconArea();
      }
      createColorArea();
      palettePanel.setLayout(gridBagLayout1);
      palettePanel.setBorder(grayBorder);

      colorPanel.setLayout(borderLayout2);
      colorPane.setLayout(borderLayout3);
      colorPanel.add(palettePanel, BorderLayout.CENTER);
      colorPane.add(colorPanel, BorderLayout.CENTER);
      this.add(colorPane,  BorderLayout.CENTER);

      for(int i=2; i < jPanel.length; i++){
          palettePanel.add(jPanel[i], new GridBagConstraints(0, i - 1, 1, 1, 0.0, 0.0
                  , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                  new Insets(0, 0, 0, 0), 0, 0));
      }
  }

  public void createColorArea(){
      final boolean isYellow = false;//basic color is yellow
    for(int i=2; i < 6; i++){
      colorIconArea.setPaletteColor(6-i, 2, isYellow);
      jPanel[i]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }

      final boolean isCyan = true;// basic color is cyan
    for(int i=0; i < 5; i++){
      colorIconArea.setPaletteColor(i,0, isCyan);
      jPanel[i+6]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }
      final boolean isGree = true;// basic color is gree
    for(int i=1; i < 2; i++){
      colorIconArea.setGrayPaletteColor(i, 2, isGree);
      jPanel[i+10]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
  }
 }

 public JPanel doGridbagLayout(Component[] comp, int column){
    JPanel pan = new JPanel();
    GridBagLayout   gb = new GridBagLayout() ;
    GridBagConstraints c = new GridBagConstraints();
    pan.setLayout(gb);
    c.insets = new Insets(0,0,0,0);
    c.anchor = GridBagConstraints.CENTER;
    c.weighty = 0.0; c.weightx = 0.0;
    c.gridwidth = 1;
    for(int i=0;i<comp.length;i++){
        c.gridwidth =1;
        if(((i%column)-column+1)==0) c.gridwidth=GridBagConstraints.REMAINDER;
        gb.setConstraints(comp[i],c);
        pan.add(comp[i],c);
    }
    return pan;
 }
 public void itemStateChanged(ItemEvent e) {
     JCheckBox box = (JCheckBox)e.getItem();
     if(box==roiCheckbox && roiCheckbox.isSelected()){
         tempColor=0;
         settingColor=Roi.getColor();
     }
     else if(box==fgCheckbox && fgCheckbox.isSelected()){
         tempColor=1;
         settingColor=Toolbar.getForegroundColor();
     }
     else if(box==bgCheckbox && bgCheckbox.isSelected()){
         tempColor=2;
         settingColor=Toolbar.getBackgroundColor();
     }
     setSelectedColor(getSelectedColor());
 }

 public void actionPerformed(ActionEvent e) {
     Color c  = getSelectedColor();
     ColorChooser cc = new ColorChooser((background?"Background":"Foreground")+" Color", c, false);
     c = cc.getColor();
     setSelectedColor(c);

 }

  public void update(Graphics g){
     paintComponents(g);

  }

  public void paintComponents(Graphics g){
     g.drawImage(image, 0, 0, this);

  }

// build color icon area as color palette
  //public class ColorIconArea extends JComponent implements java.awt.event.MouseListener{

  public class ColorIconArea {

      int column = 6;
      int iconWidth=9, iconHeight=9;
      int[] row = new int[column];
    int[] intColor = {0, 0, 0};
    JLabel[] colorLabel0 = new JLabel[(row.length-1)*column];

    Color[] color = new Color[column];
    Icon[] icon = new Icon[column];

    //default constructor
    public ColorIconArea(){
        for(int i=0; i < column; i++){
            row[i] = (column - 1) * (i + 1);
        }
        /*for (int i = 0; i < colorLabel0.length; i++) {
        }*/
    }

    public void setPaletteColor(int k, int block, boolean isCyan) {

      Color cyanColor=Color.CYAN;
      for (int i = 0; i < maxColumn; i++) {
        if (i < row[0]) {
          if (i == 0){
              cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
          setRGB(block, new Color(0, 51, 0), new Color(0, 255, 255), cyanColor);
        }
          setLabel(i, 0);
        }
        else if (i >= row[0] && i < row[1]) {
          if (i == row[0]){
              cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block+1, new Color(51, 0, 0), new Color(255, 0, 255), cyanColor);
        }
          setLabel(i, row[0]);
        }
        else if (i >= row[1] && i < row[2]) {
          if (i == row[1]){
              cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(51 * k, 51 * k, 0);
              setRGB(block, new Color(0, 0, 51), new Color(255, 0, 255), cyanColor);
        }
          setLabel(i, row[1]);
        }
        else if (i >= row[2] && i < row[3]) {
          if (i == row[2]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(51 * k, 0, 51 * k);
          setRGB(block+1, new Color(0, 51, 0), new Color(255, 255, 0), cyanColor);
        }
          setLabel(i, row[2]);
        }
        else if (i >= row[3] && i < row[4]) {
          if (i == row[3]){
              cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(0, 51 * k, 51 * k);
          setRGB(block, new Color(51, 0, 0), new Color(255, 255, 0), cyanColor);
        }
          setLabel(i, row[3]);
        }
        else if (i >= row[4] && i < row[5]) {
          if (i == row[4]){
              cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
         setRGB(block+1, new Color(0, 0, 51), new Color(0, 255, 255), cyanColor);
        }
          setLabel(i, row[4]);
        }

        colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                              MouseMotionListener() {
          public void mouseMoved(MouseEvent e) {
            colorLabel_mouseMoved(e);
          }
          public void mouseDragged(MouseEvent e) {}
        });
          colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray, 1));
      }
    }
    public void setGrayPaletteColor(int k, int block, boolean isGray) {

      Color grayColor=Color.GRAY;
      for (int i = 0; i < maxColumn; i++) {
        if (i < row[0]) {
          if (i == 0){
              grayColor = isGray ? new Color(51 * 0, 51 * 0, 51 * 0): new Color(51 * k, 0, 51 * k);
          setRGB(block, new Color(0, 0, 0), new Color(0, 0, 0), grayColor);
        }
          setLabel(i, 0);
        }
        else if (i >= row[0] && i < row[1]) {
          if (i == row[0]){
              grayColor = isGray ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), grayColor);
        }
          setLabel(i, row[0]);
        }
        else if (i >= row[1] && i < row[2]) {
          if (i == row[1]){
              grayColor = isGray ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
              setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), grayColor);
        }
          setLabel(i, row[1]);
        }
        else if (i >= row[2] && i < row[3]) {
          if (i == row[2]){
              grayColor = isGray ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
          setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), grayColor);
        }
          setLabel(i, row[2]);
        }
        else if (i >= row[3] && i < row[4]) {
          if (i == row[3]){
              grayColor = isGray ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
          setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), grayColor);
        }
          setLabel(i, row[3]);
        }
        else if (i >= row[4] && i < row[5]) {
          if (i == row[4]){
              grayColor = isGray ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
         setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), grayColor);
        }
          setLabel(i, row[4]);
        }

        colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                              MouseMotionListener() {
          public void mouseMoved(MouseEvent e) {
            //if(pressed)
            colorLabel_mouseMoved(e);
          }
          public void mouseDragged(MouseEvent e) {}
        });
          colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray,
            1));
      }
    }
   void setLabel(int i, int col){
       if((i-col) < 0)i=col;
       icon[i - col] = new ColorIcon(color[i - col], iconWidth, iconHeight);
       colorLabel0[i] = new JLabel(icon[i - col]);
       createIconToolTipText(colorLabel0[i], color[i - col]);
   }


    public void setRGB(int choose, Color rgb, Color rgbMax, Color rgbMin){

        int r=rgb.getRed();
        int g=rgb.getGreen();
        int b=rgb.getBlue();
        int maxr=rgbMax.getRed();
        int maxg=rgbMax.getGreen();
        int maxb=rgbMax.getBlue();
        int minr=rgbMin.getRed();
        int ming=rgbMin.getGreen();
        int minb=rgbMin.getBlue();
        int remeindr =0;
        int remeindg =0;
        int remeindb =0;
        int k = 0;
        int length= 0;
        if(minr >= 51)
        remeindr=minr/51;
        if(ming >= 51)
        remeindg=ming/51;
        if(minb >= 51)
        remeindb=minb/51;
        k=remeindr|remeindg|remeindb;
        //System.out.println("inc_k="+k);
        length = color.length-k;
      switch(choose){
      case 0:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
              intColor[j]=(maxr-minr)-i*r;
              if(j==1)
              intColor[j]=(maxg-ming)-i*g;
              if(j==2)
              intColor[j]=(maxb-minb)-i*b;
              }
          color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[0]=color[1];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[i]=color[k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[i]=color[k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              break;
      }
      case 1:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
              intColor[j]=(maxr-minr)-(length-i-1)*r;
              if(j==1)
              intColor[j]=(maxg-ming)-(length-i-1)*g;
              if(j==2)
              intColor[j]=(maxb-minb)-(length-i-1)*b;
              }
          color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[0]=color[1];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[i]=color[k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[i]=color[k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[i]=color[k];
              }
              break;
      }
      case 2:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
                if(r==0 && maxr == 0)intColor[j]=minr;
              else
              intColor[j]=(maxr-0)-i*r;
              if(j==1)
                if(g==0 && maxg == 0)intColor[j]=ming;
              else
              intColor[j]=(maxg-0)-i*g;
              if(j==2)
                if(b==0 && maxb == 0)intColor[j]=minb;
              else
              intColor[j]=(maxb-0)-i*b;
              }
          color[i] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[5]=color[4];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[5-i]=color[5-k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[5-i]=color[5-k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              break;
      }
      case 3:{
          for(int i = 0; i < length; i++){
              for(int j = 0; j < 3; j++){
              if(j==0)
                if(r==0 && maxr == 0)intColor[j]=minr;
              else
              intColor[j]=(maxr-0)-(length-i-1)*r;
              if(j==1)
                if(g==0 && maxg == 0)intColor[j]=ming;
              else
              intColor[j]=(maxg-0)-(length-i-1)*g;
              if(j==2)
                if(b==0 && maxb == 0)intColor[j]=minb;
              else
              intColor[j]=(maxb-0)-(length-i-1)*b;
              }
          color[i] = new Color(intColor[0], intColor[1], intColor[2]);
              }
              if(k ==1)color[5]=color[4];
              else if(k ==2){
                for(int i=0; i < k; i++)
                  color[5-i]=color[5-k];
                 }
              else if(k ==3){
                for(int i=0; i < k; i++)
                 color[5-i]=color[5-k];
              }
              else if(k ==4){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              else if(k ==5){
                for(int i=0; i < k; i++)
                     color[5-i]=color[5-k];
              }
              break;
          }
       }
    }

    public void colorLabel_mouseMoved(MouseEvent e){
      tempLabel.setBorder(BorderFactory.createLineBorder(Color.lightGray, 1));
      JLabel colorLabel = (JLabel)e.getSource();
      tempLabel = colorLabel;
      colorLabel.setBorder(BorderFactory.createLineBorder(Color.white, 1));

      settingColor = ((ColorIcon)colorLabel.getIcon()).getColor();
      StringBuffer hexValue = new StringBuffer();
      hexValue.append(Integer.toHexString(settingColor.getRGB()));
      colorHex = "0x"+hexValue.toString().toUpperCase();

      setSelectedColor(settingColor);
    }

    // create color icon ToolTipText
    public JLabel createIconToolTipText(JLabel label, Color color){
      final JLabel colorLabel = label;
      colorLabel.setToolTipText(Integer.toString(color.getRed())
                            +", "+Integer.toString(color.getGreen())
                               +", "+Integer.toString(color.getBlue()));
      return colorLabel;
    }

  }

}
